//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 6

//
//
//
//
//

extern string SymbolsPrefix = "";
extern string SymbolsSuffix = "";
extern int    WprPeriod     = 32;
extern color  EURUSDColor   = PaleVioletRed;
extern color  USDJPYColor   = Violet;
extern color  GBPUSDColor   = Red;
extern color  USDCADColor   = DeepSkyBlue;
extern color  USDSEKColor   = Blue;
extern color  USDCHFColor   = Turquoise;
extern int    LinesWidth    = 2;
extern string UniqueID      = "6 symbols WPR";

//
//
//
//
//

double eurusd[];
double usdjpy[];
double gbpusd[];
double usdcad[];
double usdsek[];
double usdchf[];

//
//
//
//
//

string indicatorFileName;
bool   returnBars;
string symbols[] = {"EURUSD","USDJPY","GBPUSD","USDCAD","USDSEK","USDCHF"};

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//

int init()
{
   SetIndexBuffer(0,eurusd); SetIndexStyle(0,DRAW_LINE,EMPTY,LinesWidth,EURUSDColor);
   SetIndexBuffer(1,usdjpy); SetIndexStyle(1,DRAW_LINE,EMPTY,LinesWidth,USDJPYColor);
   SetIndexBuffer(2,gbpusd); SetIndexStyle(2,DRAW_LINE,EMPTY,LinesWidth,GBPUSDColor);
   SetIndexBuffer(3,usdcad); SetIndexStyle(3,DRAW_LINE,EMPTY,LinesWidth,USDCADColor);
   SetIndexBuffer(4,usdsek); SetIndexStyle(4,DRAW_LINE,EMPTY,LinesWidth,USDSEKColor);
   SetIndexBuffer(5,usdchf); SetIndexStyle(5,DRAW_LINE,EMPTY,LinesWidth,USDCHFColor);

      //
      //
      //
      //
      //
      
         for (int i=0; i<6; i++) symbols[i] = SymbolsPrefix+symbols[i]+SymbolsSuffix;
         returnBars        = (SymbolsPrefix ==  "returnBars"); if (returnBars) return(0);
         indicatorFileName = WindowExpertName();
      
      //
      //
      //
      //
      //
            
   IndicatorShortName(UniqueID);
   return(0);
}

//
//
//
//
//

int deinit()
{
   for(int i = 0; i < 8; i++) ObjectDelete(UniqueID+ i);
   return (0);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int i,y,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit  = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { eurusd[0] = limit+1; return(0); }
         
            //
            //
            //
            //
            //
            
            static bool initialized = false;
            if (!initialized)
            {
               initialized = true;
               int cur = 10; 
               int cuy = 10; 
               int st  = 16;
                  sl(0,"~",cur,cuy,EURUSDColor,"EURUSD"); cuy += st;
                  sl(1,"~",cur,cuy,USDJPYColor,"USDJPY"); cuy += st;
                  sl(2,"~",cur,cuy,GBPUSDColor,"GBPUSD"); cuy += st;
                  sl(3,"~",cur,cuy,USDCADColor,"USDCAD"); cuy += st;
                  sl(4,"~",cur,cuy,USDSEKColor,"USDSEK"); cuy += st;
                  sl(5,"~",cur,cuy,USDCHFColor,"USDCHF"); cuy += st;
            }

   //
   //
   //
   //
   //

   for (i=0; i<6; i++) limit = MathMax(limit,MathMin(Bars-1,iCustom(symbols[i],0,indicatorFileName,"returnBars",0,0)));
   for(i=limit; i>=0; i--)
   {
      y = iBarShift(symbols[0],0,Time[i]); eurusd[i] = iWPR(symbols[0],0,WprPeriod,y);
      y = iBarShift(symbols[1],0,Time[i]); usdjpy[i] = iWPR(symbols[1],0,WprPeriod,y);
      y = iBarShift(symbols[2],0,Time[i]); gbpusd[i] = iWPR(symbols[2],0,WprPeriod,y);
      y = iBarShift(symbols[3],0,Time[i]); usdcad[i] = iWPR(symbols[3],0,WprPeriod,y);
      y = iBarShift(symbols[4],0,Time[i]); usdsek[i] = iWPR(symbols[4],0,WprPeriod,y);
      y = iBarShift(symbols[5],0,Time[i]); usdchf[i] = iWPR(symbols[5],0,WprPeriod,y);
   }     
   return(0);
}

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

void sl(int buffNo, string sym, int x, int y, color col, string buffLabel)
{
   int    window = WindowFind(UniqueID);
   string ID = UniqueID + buffNo;
   
      if(ObjectCreate(ID, OBJ_LABEL, window, 0, 0))
            ObjectSet(ID, OBJPROP_CORNER, 1);
            ObjectSet(ID, OBJPROP_XDISTANCE, x);
            ObjectSet(ID, OBJPROP_YDISTANCE, y);
            ObjectSetText(ID, buffLabel, 10, "Arial Bold", col);

   SetIndexStyle(buffNo,DRAW_LINE,STYLE_SOLID,LinesWidth,col);
   SetIndexLabel(buffNo,buffLabel);
}

